//allow padding strings with leading zeros
String.prototype.padLeft = function(l,c) {return Array(l-this.length+1).join(c||" ")+this}

var tcColorPicker = {
	
	//Initialize the color picker
	init: function() {
		_local.hexColor = '000000';
		_local.rgb = [0,0,0];
		_local.ceiColor = [0,0];
		_local.paletteImage = 'images/'+_getImage('Palette');
		_local.targetWidth = _getWidth('Target');
		_local.targetHeight = _getHeight('Target');
		tcColorPicker.createCanvas();
	},
	
	//Create and load the in-memory canvas
	createCanvas: function() {
		tcColorPicker.getPalette();
 		_local.canvas = Canvas(_local.imgWidth, _local.imgHeight);
 		_local.canvas.loadImage(_local.paletteImage, function() {
 			tcColorPicker.updateInterface();
		});
	},

	//Get the current palette details
	getPalette: function() {
		_local.imgLeft = _getLeft('Palette');
		_local.imgRight = _getRight('Palette');
		_local.imgTop = _getTop('Palette');
		_local.imgBottom = _getBottom('Palette');
		_local.imgWidth = _getWidth('Palette');
		_local.imgHeight = _getHeight('Palette');
	},
	
	//Update the UI after the canvas loads
	updateInterface: function() {
		_setEnabled('MainGroup',true);
		_setSize('Target',_local.targetWidth,_local.targetHeight);
		tcColorPicker.updateColor(_getCenter('Target')[0], _getCenter('Target')[1]);
		_animateAlpha('MainGroup',1);
		_animateAlpha('Target',1);
	},

	//Keep target from dragging off the palette
	updateTargetLocation: function() {
		if (_getCenter('Target')[0] < _local.imgLeft) {
			_setCenter('Target',_local.imgLeft,_getCenter('Target')[1]);
		} else if (_getCenter('Target')[0] > _local.imgRight-1) {
			_setCenter('Target',_local.imgRight-1,_getCenter('Target')[1]);
		}
		if (_getCenter('Target')[1] < _local.imgTop) {
			_setCenter('Target',_getCenter('Target')[0],_local.imgTop);
		} else if (_getCenter('Target')[1] > _local.imgBottom-1) {
			_setCenter('Target',_getCenter('Target')[0],_local.imgBottom-1);
		}
		return _getCenter('Target');
	},
	
	//Helper function for point_in_rectangle
	point_between: function(min, p, max){
	  result = false;
	  if (min < max){
		if (p > min && p < max){
		  result = true;
		}
	  }
	  if (min > max){
		if (p > max && p < min){
		  result = true
		}
	  }
	  if (p == min || p == max){
		result = true;
	  }
	  return result;
	},

	//Test if touched the target
	point_in_rectangle: function(x, y, left, top, right, bottom){
	  result = false;
	  if (tcColorPicker.point_between(left,x,right) && tcColorPicker.point_between(top,y,bottom)){
		result = true;
	  }
	  return result;
	},

	//Format the hex color value
	hexValue: function(imgData) {
		var hex0 = imgData[0].toString(16).padLeft(2,'0');
		var hex1 = imgData[1].toString(16).padLeft(2,'0');
		var hex2 = imgData[2].toString(16).padLeft(2,'0');
		_local.ceiColor = colors().getCIEColor(hex0+hex1+hex2);
		return hex0+hex1+hex2;
	},

	//Update the on-screen color controls
	updateColor: function(x,y) {
		_local.canvas.getImageData(x, y, function(imgData) {
			_local.hexColor = tcColorPicker.hexValue(imgData);
			_setText('HexValue','#'+_local.hexColor);
			_local.rgb = colors().hexToRGB(_local.hexColor);
			_setText('RGBValue','R:'+_local.rgb[0]+',G:'+_local.rgb[1]+',B:'+_local.rgb[2]);
			_setBackgroundColor('Color','#'+_local.hexColor);
		});
	},
};